#define NDEBUG          /* Debug phase finished. */
#include <assert.h>
#include <stdlib.h>
#include <string.h>

/* See assert() for the definition. */
extern void *xmalloc(size_t size);

/*
 * Return a duplicate of the argument string, allocating
 * dynamically a memory area.
 */
char *xstrdup(const char *s)
{
    char *ns;

    assert(s != NULL);  /* Catch invalid arguments. */
    ns = (char *)xmalloc(strlen(s) + 1);
    assert(ns != NULL); /* Catch unexpected behaviors. */
    strcpy(ns, s);

    return ns;
}
