#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * Return a pointer to an allocated region of memory of the
 * specified size.  Check for unexpected errors.
 */
void *xmalloc(size_t size)
{
    void *p;

    assert(size > 0);
    if ((p = malloc(size)) == NULL) {
	fprintf(stderr, "No more available memory\n");
	exit(1);
    }

    return p;
}
