#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * rm.c: remove the specified files.
 * usage: rm <filename>...
 */
int main(int argc, char **argv)
{
    const char *program_name = argv[0];

    if (argc < 2) {
	fprintf(stderr, "usage: %s <filename>...\n", program_name);
	return EXIT_FAILURE;
    }

    while (--argc > 0)
	if (remove(*++argv) != 0) {
	    fprintf(stderr, "%s:%s: %s\n", program_name, *argv,
		    strerror(errno));
	    return EXIT_FAILURE;
	}

    return EXIT_SUCCESS;
}
