#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * tmpcheck.c: tryes to open a user specified number of temporary
 *             files and to write some data into the files.
 * usage: tmpcheck <num>
 */
int main(int argc, char **argv)
{
    FILE **tmpvec;
    int i, num;
    char data[] = "Some data";

    if (argc != 2 || (num = atoi(argv[1])) < 1) {
	fprintf(stderr, "usage: %s <num>\n", argv[0]);
	return EXIT_FAILURE;
    }

    tmpvec = (FILE **)malloc(sizeof(FILE) * num);
    if (tmpvec == NULL) {
	fprintf(stderr, "%s: cannot allocate memory\n", argv[0]);
	return EXIT_FAILURE;
    }

    for (i = 0; i < num; ++i) {
	if ((tmpvec[i] = tmpfile()) == NULL) {
	    fprintf(stderr, "%s: %s\n", argv[0], strerror(errno));
	    return EXIT_FAILURE;
	}
	if (fwrite(data, 1, sizeof(data), tmpvec[i])
	    != sizeof(data)) {
	    fprintf(stderr, "%s: %s\n", argv[0], strerror(errno));
	    return EXIT_FAILURE;
	}
    }

    for (i = 0; i < num; ++i)
	fclose(tmpvec[i]);
    free(tmpvec);

    printf("\nSuccess for %d temporary files\n", num);

    return EXIT_SUCCESS;
}
