#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * Duplicate the argument object.
 */
void *objdup(void *ptr, size_t size)
{
    void *nptr;

    if ((nptr = malloc(size)) != NULL)
	memcpy(nptr, ptr, size);

    return nptr;
}

int main(void)
{
    struct s { int a; char c; } obj, *obj2;

    obj.a = 1; obj.c = 'x';
    if ((obj2 = objdup(&obj, sizeof obj)) == NULL) {
	fprintf(stderr, "Cannot allocate memory\n");
	return EXIT_FAILURE;
    }
    if (obj.a != obj2->a || obj.c != obj2->c) {
	free(obj2);
	fprintf(stderr, "Unexpected behavior\n");
	return EXIT_FAILURE;
    }
    free(obj2);

    return EXIT_SUCCESS;
}
